#version 430 core

layout (points) in;
layout (triangle_strip) out;
layout (max_vertices = 4) out;    
   
uniform mat4 VP;
uniform mat4 V;
uniform vec2 size;
uniform vec3 camera_worldspace; 


out vec2 fragUV;

void main (void)
{
	vec4 pos = gl_in[0].gl_Position;

	vec3 up = vec3(0, 1, 0);
	vec3 look = vec3(pos) - camera_worldspace;
	vec3 right = normalize(cross(look, up));
	
	gl_Position = VP * (pos + vec4(right * -size.x, 0));
	fragUV = vec2(0.0, 0.0);
	EmitVertex();

	gl_Position = VP * (pos + vec4(right * size.x, 0));
	fragUV = vec2(1.0, 0.0);
	EmitVertex();

	gl_Position = VP * (pos + vec4(right * -size.x + up * 2 * size.y, 0));
	fragUV = vec2(0.0, 1.0);
	EmitVertex();

	gl_Position = VP * (pos + vec4(right * size.x + up * 2 * size.y, 0));
	fragUV = vec2(1.0, 1.0);
	EmitVertex();

	EndPrimitive();


	/*vec4 positions[8] = { // worldspace
		pos + vec4(-size.x, 0, 0, 0),
		pos + vec4(size.x, 0, 0, 0),
		pos + vec4(-size.x, 2*size.y, 0, 0),
		pos + vec4(size.x, 2*size.y, 0, 0),

		pos + vec4(0, 0, size.x, 0),
		pos + vec4(0, 0, -size.x, 0),
		pos + vec4(0, 2*size.y, size.x, 0),
		pos + vec4(0, 2*size.y, -size.x, 0)
	};

	vec2 uvs[4] = {
		vec2(0.0, 0.0),
		vec2(1.0, 0.0),
		vec2(0.0, 1.0),
		vec2(1.0, 1.0)
	};

	// backplanes

	// distance from c to x plane vertices -> x halfplane
	float dist_x_left = length(vec3(V * positions[0]));
	float dist_x_right = length(vec3(V * positions[1]));

	if(dist_x_right > dist_x_left) {
		gl_Position = VP *  (pos);
		fragUV = vec2(0.5, 0.0);
		EmitVertex();

		gl_Position = VP *  positions[1];
		fragUV = vec2(1.0, 0.0);
		EmitVertex();

		gl_Position = VP *  (pos + vec4(0, 2*size.y, 0, 0));
		fragUV = vec2(0.5, 1.0);
		EmitVertex();

		gl_Position = VP *  positions[3];
		fragUV = vec2(1.0, 1.0);
		EmitVertex();
	} else {		
		gl_Position = VP *  positions[0];
		fragUV = vec2(0.0, 0.0);
		EmitVertex();

		gl_Position = VP *  (pos);
		fragUV = vec2(0.5, 0.0);
		EmitVertex();
		
		gl_Position = VP *  positions[2];
		fragUV = vec2(0.0, 1.0);
		EmitVertex();

		gl_Position = VP *  (pos + vec4(0, 2*size.y, 0, 0));
		fragUV = vec2(0.5, 1.0);
		EmitVertex();
	}
	EndPrimitive();  

	// distance from c to y plane vertices -> y halfplane

	float dist_y_left = length(vec3(V * positions[4]));
	float dist_y_right = length(vec3(V * positions[5]));

	if(dist_y_right > dist_y_left) {
		gl_Position = VP *  (pos);
		fragUV = vec2(0.5, 0.0);
		EmitVertex();

		gl_Position = VP *  positions[5];
		fragUV = vec2(1.0, 0.0);
		EmitVertex();

		gl_Position = VP *  (pos + vec4(0, 2*size.y, 0, 0));
		fragUV = vec2(0.5, 1.0);
		EmitVertex();

		gl_Position = VP *  positions[7];
		fragUV = vec2(1.0, 1.0);
		EmitVertex();
	} else {	
		gl_Position = VP *  positions[4];
		fragUV = vec2(0.0, 0.0);
		EmitVertex();

		gl_Position = VP *  (pos);
		fragUV = vec2(0.5, 0.0);
		EmitVertex();
		
		gl_Position = VP *  positions[6];
		fragUV = vec2(0.0, 1.0);
		EmitVertex();

		gl_Position = VP *  (pos + vec4(0, 2*size.y, 0, 0));
		fragUV = vec2(0.5, 1.0);
		EmitVertex();
	}
	EndPrimitive();


	// frontplanes

	// distance from c to x plane vertices -> x halfplane
	dist_x_left = length(vec3(V * positions[0]));
	dist_x_right = length(vec3(V * positions[1]));

	if(dist_x_right < dist_x_left) {
		gl_Position = VP *  (pos);
		fragUV = vec2(0.5, 0.0);
		EmitVertex();

		gl_Position = VP *  positions[1];
		fragUV = vec2(1.0, 0.0);
		EmitVertex();
		
		gl_Position = VP *  (pos + vec4(0, 2*size.y, 0, 0));
		fragUV = vec2(0.5, 1.0);
		EmitVertex();

		gl_Position = VP *  positions[3];
		fragUV = vec2(1.0, 1.0);
		EmitVertex();
	} else {		
		gl_Position = VP *  positions[0];
		fragUV = vec2(0.0, 0.0);
		EmitVertex();

		gl_Position = VP *  (pos);
		fragUV = vec2(0.5, 0.0);
		EmitVertex();
		
		gl_Position = VP *  positions[2];
		fragUV = vec2(0.0, 1.0);
		EmitVertex();

		gl_Position = VP *  (pos + vec4(0, 2*size.y, 0, 0));
		fragUV = vec2(0.5, 1.0);
		EmitVertex();
	}
	EndPrimitive(); 

	// distance from c to y plane vertices -> y halfplane

	dist_y_left = length(vec3(V * positions[4]));
	dist_y_right = length(vec3(V * positions[5]));

	if(dist_y_right < dist_y_left) {
		gl_Position = VP *  (pos);
		fragUV = vec2(0.5, 0.0);
		EmitVertex();

		gl_Position = VP *  positions[5];
		fragUV = vec2(1.0, 0.0);
		EmitVertex();

		gl_Position = VP *  (pos + vec4(0, 2*size.y, 0, 0));
		fragUV = vec2(0.5, 1.0);
		EmitVertex();

		gl_Position = VP *  positions[7];
		fragUV = vec2(1.0, 1.0);
		EmitVertex();
	} else {	
		gl_Position = VP *  positions[4];
		fragUV = vec2(0.0, 0.0);
		EmitVertex();

		gl_Position = VP *  (pos);
		fragUV = vec2(0.5, 0.0);
		EmitVertex();
		
		gl_Position = VP *  positions[6];
		fragUV = vec2(0.0, 1.0);
		EmitVertex();

		gl_Position = VP *  (pos + vec4(0, 2*size.y, 0, 0));
		fragUV = vec2(0.5, 1.0);
		EmitVertex();
	}
	EndPrimitive();*/
}   