#version 430 core

layout(location = 0) in vec3 position;
layout(location = 1) in vec3 normal;

uniform mat4 MVP;
uniform mat4 M;
uniform mat4 V;

uniform mat3 NormalM;

out vec3 eyeDirection_cameraspace;
out vec3 normal_cameraspace;
out vec3 fragPosition_cameraspace;

void main() {
	
	gl_Position = MVP * vec4(position, 1);

	// calculate vertex position in camera space
	vec3 vertexPosition_cameraspace = ( V * M * vec4(position, 1)).xyz;
	eyeDirection_cameraspace = vec3(0,0,0) - vertexPosition_cameraspace;
	fragPosition_cameraspace = vertexPosition_cameraspace;

	// calculate vertex normal in camera space
	normal_cameraspace = ( V * vec4(NormalM * normal, 0) ).xyz;
}