#version 430 core

#define MAX_LIGHTS 10

in vec3 eyeDirection_cameraspace;
in vec3 fragPosition_cameraspace;
in vec3 position_modelspace;

uniform struct PointLight {
	vec3 position;
	vec3 diffColor;
	vec3 specColor;
	vec3 attenuation;
} pointLights[MAX_LIGHTS];

uniform struct DirectionalLight {
	vec3 direction;
	vec3 diffColor;
	vec3 specColor;
} directionalLights[MAX_LIGHTS];

uniform uint nbPointLights;
uniform uint nbDirectionalLights;

uniform vec3 matAmbColor;
uniform vec3 matDiffColor;
uniform vec3 matSpecColor;
uniform float matShininess;
uniform vec3 matIlluminationWeights;

uniform mat4 V;
uniform mat3 NormalM;

in vec2 UV;
in vec4 color;

out vec4 fragColor;

void main() {

	// compute alpha from distance to center
    float r = length(UV*2.0-1.0)*2;
    float i = exp(-r*r) * 0.1;
    if (i < 0.001) discard;

	fragColor = vec4(color.xyz, i);
}
