#version 430 core

#define particleSize 8

layout(location = 0) in vec3 position;

uniform mat4 MV;
uniform mat4 P;

out vec2 UV;
out vec4 color;

void main() {
	// use gl_VertexID (= id from index buffer) to get particle position of SSBO and for index of UV

	UV = vec2(position);

	vec4 particlePosEye = MV * vec4(0,0,0,1);
	vec4 vertexPosEye = particlePosEye + vec4(UV * 2.0f - 1.0f, 0, 0) * particleSize;

	gl_Position = P * vertexPosEye;
	gl_Position = vec4(gl_Position.xy, gl_Position.w - 0.01, gl_Position.w); //so z component is after perspective divide always 1.0 and so always behind all other scene objects 

	color = vec4(1, 1, 1, 1);
}