#version 430 core

layout(location = 0) in vec3 position;

uniform float waveOffset;
uniform sampler2D heightMap;

float calcHeight(vec2 position) {
	vec4 textureHeight = texture(heightMap,  position);
	float height = textureHeight.r;
	return height  / 2.0f;
}

void main(){

	vec2 terrainUV = position.xz / 2.0 + vec2(0.5, 0.5); //move our texture coords, because the meshes lie between -1.0 and 1.0, while the texture coordinates must lie between 0.0 and 1.0

    float height = calcHeight(terrainUV);

	gl_Position = vec4(position.x, height, position.z, 1.0);
}