#version 430 core

layout(location = 0) in vec3 position;

uniform float waveOffset;
uniform sampler2D surfaceMap;

float calcWaterHeight(vec2 position) {
	float height1 = texture(surfaceMap, clamp(mod(vec2(position.x + waveOffset, position.y) * 2, 1.0), 0.001, 0.999)).r / 192.0;
	float height2 = texture(surfaceMap, clamp(mod(vec2(position.x, position.y  + waveOffset * 2) * 4, 1.0), 0.001, 0.999)).r / 256.0;
	float height3 = texture(surfaceMap, clamp(mod(vec2(position.x + waveOffset, position.y - waveOffset) * 4, 1.0), 0.001, 0.999)).r / 192.0;
	float height4 = texture(surfaceMap, clamp(mod(vec2(position.x + 0.8 * waveOffset, position.y + 1.2 * waveOffset) * 3, 1.0), 0.001, 0.999)).r / 192.0;

	return height1 + height2 + height3 + height4;
}

void main(){

	vec2 terrainUV = position.xz / 2.0 + vec2(0.5, 0.5); //move our texture coords, because the meshes lie between -1.0 and 1.0, while the texture coordinates must lie between 0.0 and 1.0

    float height = calcWaterHeight(terrainUV);

	gl_Position = vec4(position.x, height, position.z, 1.0);
}